cad 订阅
计算机辅助设计(Computer Aided Design)指利用计算机及其图形设备帮助设计人员进行设计工作。在设计中通常要用计算机对不同方案进行大量的计算、分析和比较,以决定最优方案;各种设计信息,不论是数字的、文字的或图形的,都能存放在计算机的内存或外存里,并能快速地检索;设计人员通常用草图开始设计,将草图变为工作图的繁重工作可以交给计算机完成;由计算机自动产生的设计结果,可以快速作出图形,使设计人员及时对设计做出判断和修改;利用计算机可以进行与图形的编辑、放大、缩小、平移、复制和旋转等有关的图形数据加工工作。 展开全文
计算机辅助设计(Computer Aided Design)指利用计算机及其图形设备帮助设计人员进行设计工作。在设计中通常要用计算机对不同方案进行大量的计算、分析和比较,以决定最优方案;各种设计信息,不论是数字的、文字的或图形的,都能存放在计算机的内存或外存里,并能快速地检索;设计人员通常用草图开始设计,将草图变为工作图的繁重工作可以交给计算机完成;由计算机自动产生的设计结果,可以快速作出图形,使设计人员及时对设计做出判断和修改;利用计算机可以进行与图形的编辑、放大、缩小、平移、复制和旋转等有关的图形数据加工工作。
信息
外文名
Computer Aided Design
简    称
CAD
诞    生
二十世纪60年代
中文名
计算机辅助设计
功    能
帮助设计人员进行设计工作
属    性
工程技术
CAD基本信息
CAD技术作为杰出的工程技术成就,已广泛地应用于工程设计的各个领域。CAD系统的发展和应用使传统的产品设计方法与生产模式发生了深刻的变化,产生了巨大的社会经济效益。目前CAD技术研究热点有计算机辅助概念设计、计算机支持的协同设计、海量信息存储、管理及检索、设计法研究及其相关问题、支持创新设计等。 可以预见技术将有新的飞跃,同时还会引起一场设计变革 [1]  。CAD技术一直处于不断发展与探索之中。 应用 CAD技术起到了提高企业设计效率、优化设计方案、减轻技术人员的劳动强度、缩短设计周期、加强设计标准化等作用。 越来越多的人认识到 CAD是一种巨大的生产力。 CAD技术已经广泛地应用在机械、电子、航天、化工、建筑等行业。并行设计、协同设计、智能设计、虚拟设计、敏捷设计、全生命周期设计等设计方法代表了现代产品设计模式的发展方向。 随着人工智能、多媒体、虚拟现实、信息等技术的进一步发展, CAD技术必然朝着集成化、智能化、协同化的方向发展。企业 CAD和CIMS技术必须走一条以电子商务为目标、循序渐进的道路。 从企业内部出发,实现集成化、智能化和网络化的管理,用电子商务跨越企业的边界,实现真正意义上的面向客户、企业内部和供应商之间的敏捷供应链 [1]  。
收起全文
精华内容
下载资源
问答
  • Python 二次开发 AutoCAD 简介

    万次阅读 多人点赞 2018-12-13 18:20:21
    cad是 python是 Active X 是 pyautocad模块由俄罗斯工程师开发,因参考实例较少,工程需要,现将模块中一些基本的用法,做出简要说明,叙述力求简洁明了, 因个人水平有限,文中难免有所疏漏,还请各位大神不吝...



    Blog Links





    转载请注明出处!



    一、前沿


      AutoCAD(Autodesk Computer Aided Design)是 Autodesk(欧特克)公司首次于 1982 年开发的自动计算机辅助设计软件,在土木建筑,装饰装潢,工业制图,工程制图,电子工业,服装加工等诸多领域有着广泛的应用,主要用于二维绘图、详细绘制、设计文档和基本三维设计,现已经成为国际上广为流行的绘图工具。


      上世纪 80 年代末 90 年代初, Guido van Rossum 在荷兰国家数学和计算机科学研究所设计出计算机程序设计语言 Python 。 Python 是一个高层次的结合了解释性、编译性、互动性和面向对象的脚本语言,具有很强的可读性。相比其他语言,语法结构更具特色。同时,它也是一种跨平台的计算机程序设计语言,越来越多地用于独立的、大型项目的开发。



      为什么采用 Python 语言二次开发 AutoCAD ?


      • Python 是一种代表简单主义思想的语言,简单易学,应用范围广泛 。

      • Python 拥有大量第三方库,可轻易实现各种应用程序间的数据交换,如 AutoCAD 与 Excel / Word 间的数据交换。

      • 只要具有基础的 Python 编程能力,就可实现对 AutoCAD 的二次开发,而不必特意学习 VBA 或者 LISP 。



      吾生也有涯,而知也无涯,以有涯随无涯,殆己。



      总之,人的精力是有限的, Windows 平台上的应用程序是各种各样的,我们力争只熟练掌握一门编程语言就能将各种应用程序串联起来,以实现数据的顺利传递,从而大幅度地提高工作效率和质量。这也是我当时在全网参考代码很少的情况下坚持用 Python 调用 CAD 的原因。


      这个过程并非顺利,本人纯野生学习 Python,很多小 bug 都要查很久的资料才能解决。因粗心看错了帮助文档的参数定义,在绘制椭圆这卡了将近一个月;因不了解 CAD 系统对颜色的定义规则,在模型空间背景色设置上卡了将近3个月,通过不断测试,硬是靠最原始的总结规律得到了颜色指定的换算公式;因不了解 Python 中的数据类型如何对应 AutoCAD 中的 Variant,图案填充这又卡了好几个月,最终在 ke1078 大神的帮助下,顺利实现了图案填充的绘制。


      为了使后续的学习者少走弯路,把宝贵的时间用于所研究的问题上,而非软件操作层面,特此,将本人所了解到的 Python 语言二次开发 CAD 的有关内容记录在此系列博客上。还需说明的是,因本人能力和水平确实有限,博客中的有关表述可能不严谨,甚至错误,还请大家及时批评指正。



    在这里插入图片描述




    二、ActiveX Automation


      AutoCAD 二次开发主要接口有 ObjectARX 接口、.net API 接口、AutoLisp 接口、ActiveX (com) 接口,更多详见: AutoCAD二次开发简介


    在这里插入图片描述

    AutoCAD API Performance


      ActiveX Automation 是 ActiveX 为 Windows 用户提供的一项重要技术,可以使各应用程序间通过数据嵌入或链接的方式共享数据,并在 Windows 系统统一管理下进行协调,让这些应用程序以一定的流程相互沟通,相互控制,即一个程序暴露其可用对象,另一个程序控制这些对象,设置属性、调用方法,从而实现某种功能,完成所要求的动作。


      AutoCAD 程序开放某些对象给 Windows 系统,使用程序语言并通过 ActiveX Automation,我们就可以对这些对象进行存取。 AutoCAD ActiveX 接口的主要构件就对象,每一个显露的对象均精确代表一个 AutoCAD 组件。


      AutoCAD 以分层结构来组织对象,分层结构的视图称为“对象模型”,如下图所示。Application 对象是 AutoCAD ActiveX Automation 对象模型的根对象,通过它,用户可以访问任何其他的对象或任何对象指定的特性或方法。对象模型给出了上级对象与下级对象之间的访问关系。



    在这里插入图片描述


    AutoCAD对象模型 (部分)


      AutoCAD 对象都至少具有一个属性,用于描述对象。例如,圆具有半径、面积、线型等属性,通过这些属性能描述出一个具体的圆。


      • 参考资料AutoCAD ActiveX 二次开发技术




    三、开发文档/工具


    3.1 AutoCAD Help


      AutoCAD 二次开发的两个官方帮助文档: ActiveX Reference Guide ActiveX Develop’s Guide 可在 CAD 的安装目中获得,两个文件名分别为:acadauto.chm 和 acad_aag.chm 。


      可按如下方式获取: 首先,安装文件搜索神器 Everything;然后,在搜索栏内输入 acadauto.chm,便可看到 ActiveX Reference Guide 文件及其所在路径,该文件是随 AutoCAD 程序的安装一起附带到你的电脑内的,只要你安装了 CAD,该文件必然存在。



    在这里插入图片描述


    在这里插入图片描述

    帮助文档的获取



    3.2 ArxDbg


      ArxDbg 是 ObjectARX SDK 中包含多年的示例项目的名称。它的主要目的是演示如何使用 ObjectARX API,但它本身就是一个完全独立的实用程序。ObjectARX 程序员经常在开发期间使用此实用程序来测试和执行他们的应用程序代码。更多详见: [ObjectARX] ArxDbg介绍、自动加载及其下载


    在这里插入图片描述


    ArxDbg

      • 下载链接ACAD二次开发必备辅助工具-ArxDbg 2005-2021各版本




    四、可用Python库


      在介绍各种 Python 库前,有必要对 AutoCAD 的文件系统做一个简单的了解。


      dwg 是 AutoCAD 以及基于 AutoCAD 的软件保存设计数据所用的一种专有文件格式 (AutoCAD的图形文件)。


      dxf 是 AutoCAD 绘图交换文件,它是 Autodesk 公司开发的用于 AutoCAD 与其它软件之间进行 CAD 数据交换的 CAD 数据文件格式。


      dxf (图形交换文件) 是一种开放的矢量数据格式,它包含对应的 dwg 文件的全部信息,主要用于不同版本 CAD 间的数据交换。可以分为两类:ASCII 格式和二进制格式;ASCII 具有可读性好的特点,但占用的空间较大;二进制格式则占用的空间小、读取速度快。由于 AutoCAD 是最流行的 CAD 系统,DXF 也被广泛使用,成为事实上的标准。绝大多数 CAD 系统都能读入或输出 DXF 文件。ASCII 格式的 DXF 可以用文本编辑器进行查看。它包含对应的 dwg 文件的全部信息,不是 ASCII 码形式,可读性差,但用它形成图形速度快,不同类型的计算机哪怕是用同一版本的文件,其 dwg 文件也是不可交换的。为了克服这一缺点,AutoCAD 提供了 dxf 类型文件,其内部为 ASCII 码,这样不同类型的计算机可通过交换 dxf 文件来达到交换图形的目的,由于 dxf 文件可读性好,用户可方便地对它进行修改,编程,达到从外部图形进行编辑和修改的目的。


      dwg 格式以及它的 ASCII 格式变体 dxf,已经成为 CAD 制图数据交换中的事实文件标准。



      .dwg:脱离 AutoCAD 软件环境读写 dwg 格式文件,基本无法实现,通过 COM 自动化操作是一个可选的方案。[1]


      .dxf:是与其它软件进行 CAD 数据交换的文件格式,可脱离 AutoCAD 软件环境读写,如利用 ezdxf 库。[1]




    4.1 pyautocad


      pyautocad 库由俄罗斯工程师 Roman Haritonov 开发,用于简化使用 Python 语言书写 AutoCAD ActiveX Automation 脚本。主要参考资料如下:


      • PiPy: pyautocad 0.2.0

      • GitHub: reclosedev/pyautocad

      • Documentation: pyautocad’s documentation

      • Blog: 1. Python3操作AutoCAD:利用pyautocad库能够自动化地进行CAD画图. 陆壹爵爷

           2. 利用python控制Autocad:pyautocad. bsider



    在这里插入图片描述

    pyautocad库与AutoCAD的连接


      事实上,pyautocad 库仅仅起到了接口作用,pyautocad 利用 comtypes.client 启动或连接 CAD (pyautocad源代码),如下图所示:


    pyautocad源代码


    pyautocad源代码 (部分)


    import comtypes.client
    
    try:
        acad = comtypes.client.GetActiveObject('AutoCAD.Application', dynamic=True)
    except WindowsError:
        acad = comtypes.client.CreateObject('AutoCAD.Application', dynamic=True)
        acad.Visible = True
    
    pyautocad启动/连接CAD的Python代码


    4.2 pywin32


      pywin32 是一个 Python 库,为 Python 提供访问 Windows API 的扩展,提供了齐全的 windows 常量、接口、线程以及 COM 机制等。了解更多详见博客:如何利用Python和win32编程避免重复性体力劳动(一) 。主要参考资料如下:


      • PiPy: https://pypi.org/project/pywin32

      • Github: https://github.com/mhammond/pywin32


      • 与 CAD 的连接

    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    import win32com.client as win32
    
    wincad = win32.Dispatch("AutoCAD.Application")
    doc = wincad.ActiveDocument
    msp = doc.ModelSpace
    
    doc.Utility.Prompt("Hello! Autocad from pywin32com.\n")
    
    print(doc.Name)
    

      • 示例

    在这里插入图片描述

    win32com连接CAD示例 (与Excel交互)


      • pywin32 Help

      首先确保你已经成功安装了 pywin32 模块,然后在搜索神器 Everything 的搜索栏中输入 PyWin32.chm,便可得到其所在的路径。



    在这里插入图片描述

    PyWin32帮助文档的获取

    在这里插入图片描述

    PyWin32帮助文档


    4.3 ezdxf


      • ezdxf 库的安装

      如已安装 Anaconda,在 Anaconda Prompt 中键入 pip install ezdxf 便可自动完成该库的导入,如下图所示;如未安装 Anaconda,也可 pip 手动导入,其在 PyPI (Python Package Index) 上的注册地址为:https://pypi.org/project/ezdxf/

    在这里插入图片描述


      • Github: https://github.com/mozman/ezdxf

      • Documentation: https://ezdxf.readthedocs.io/en/stable/

      • Blog使用Python读写DXF和DWG文件


      • 示例

    import ezdxf
    
    # Create a new DXF document.
    doc = ezdxf.new(dxfversion='R2010')
    
    # Create new table entries (layers, linetypes, text styles, ...).
    doc.layers.new('TEXTLAYER', dxfattribs={'color': 2})
    
    # DXF entities (LINE, TEXT, ...) reside in a layout (modelspace,
    # paperspace layout or block definition).
    msp = doc.modelspace()
    
    # Add entities to a layout by factory methods: layout.add_...()
    msp.add_line((0, 0), (10, 10), dxfattribs={'color': 7})
    msp.add_text(
        'Test',
        dxfattribs={
            'layer': 'TEXTLAYER'
        }).set_pos((0, 0.2), align='CENTER')
    
    # Save DXF document.
    doc.saveas('test.dxf')
    

    在这里插入图片描述

    ezdxf生成.dxf文件


    4.4 dxfgrabber


      • Github: https://github.com/mozman/dxfgrabber

      • Documentation: https://dxfgrabber.readthedocs.io/en/latest/



    4.5 dxfwrite


      • Github: https://github.com/mozman/dxfwrite

      • Documentation: https://dxfwrite.readthedocs.io/en/latest/



    4.6 gdal


      • Blog使用Python读写DXF和DWG文件



      以上,便是截止目前常见的 AutoCAD 二次开发 Python 库,可根据个人需要,选择合适的 Python 库。


      若想创建 .dwg 文件,建议采用 pywin32 库;若想创建 .dxf 文件,同时脱离 AutoCAD 软件环境,则可采用 ezdxf、dxfwrite,也可以采用 pywin32 库绘制好相应的文件后,以另存为的方式创建 .dxf 文件。


      事实上,pyautocad 库和 pywin32 库仅仅起到了接口作用,它们只是构建好数据传输的通道,真正实现图形创建的是 AutoCAD 程序本身,AutoCAD 应用程序接收来自 Python 的命令后,完成图形的绘制等。因此,大家不必纠结于采用何种方式与 CAD 建立连接。


      就反应速度而言,pyautocad 库相对较慢,而且好多高级的绘图功能 pyautocad 库暂时无法实现,如图案填充、选择集功能的实现等。所以,建议大家采用 pywin32 库 即 win32com 方式连接 CAD 创建 .dwg 文件。除了速度方面的原因外,利用这个库,可以与 Excel、Word、Sap2000 等其他程序构建起数据传输通道,看到这是不是觉得很爽,对的,我们的最终目的就是要用 Python 将各种计算软件联系起来,以实现某一工程问题的快速处理。例如一幢超高层建筑的设计,我们可以按如下方式进行: Excel 提供用户输入数据、SAP2000 进行全局多工况内力弹性计算、Abaqus 完成局部弹塑性分析、nCode 进行个别钢构件的高周疲劳分析、AutoCAD 完成施工图的绘制、Word 生成最终的计算说明文件,以上操作均可在 Python 的控制下快速进行。



      • Python 二次开发 Excel 简介

      • Python 二次开发 SAP2000 概述

      • Abaqus 二次开发 基本概念

      • nCodeDL 疲劳分析 简明教程

      • Python 二次开发 Word 简介



    在这里插入图片描述

    .dwg文件的创建逻辑


    在这里插入图片描述

    .dxf文件的创建逻辑



    五、与CAD的连接


    5.1 ProgID


      如果电脑中安装了不止一个版本的 AutoCAD 为了顺利完成指定版本 CAD 的调用则需指定 ProgID,即 ×××.Dispatch(“AutoCAD.Application.19”),其中 “AutoCAD.Application.19” 就是 2014 版 AutoCAD 的 ProgID。如下代码将建立起 Python 与 2010 版 AutoCAD 的连接:


    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    import win32com.client
    import pythoncom
    
    wincad = win32com.client.Dispatch("AutoCAD.Application.18")
    doc = wincad.ActiveDocument
    doc.Utility.Prompt("Hello! Autocad from pywin32com.\n")
    msp = doc.ModelSpace
    print(doc.Name)
    

      根据 CAD 版本的不同, ProgID 可能会发生变化,部分版本 CAD 的 ProgID 如下:


    AutoCAD 版本 ProgID
    2010 AutoCAD.Application.18
    2014 AutoCAD.Application.19

      常见版本 CAD 的 ProgID 详见博文: autocad application 版本


      另外,CAD 的 ProgID 可在官方二次开发帮助文档 ActiveX Reference Guide 中查看,具体操作如下图所示:


    在这里插入图片描述


    ProgID的查看


    5.2 示例


    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    from pyautocad import Autocad, APoint
    import comtypes.client
    import time
    
    # 1.CAD自动启动
    ProgID = "AutoCAD.Application.19"  # 2014版CADProgramID
    
    try:
        acad = comtypes.client.GetActiveObject(ProgID, dynamic=True)
    except WindowsError:
        acad = comtypes.client.CreateObject(ProgID, dynamic=True)
        acad.Visible = True
    
    print("The program will pause for 60 seconds.")  # 防止报错
    time.sleep(60)  # 程序暂停60s运行
    
    # 2.连接方式的转换
    acad = Autocad(create_if_not_exists=True)
    acad.prompt("Hello! AutoCAD from pyautocad.")
    doc = acad.ActiveDocument
    print(doc.Name)
    msp = doc.ModelSpace
    
    dwgobj = acad.ActiveDocument.Application.Documents.Add("")
    dwgobj.Activate()  # 设为当前文件。
    doc = acad.ActiveDocument
    print(doc.Name)
    msp = doc.ModelSpace
    
    # 3.创建图元
    x1, y1 = 0, 0
    x2, y2 = 100, 100
    p1, p2, = APoint(x1, y1), APoint(x2, y2)
    msp.AddLine(p1, p2)
    
    # 4.文件保存
    directory = r"D:"  # 工作目录
    dwgname = "ZK.dwg"  # 工作目录
    path = directory + "\\" + dwgname
    dwgobj.Close(True, path)
    
    # 5.程序退出
    acad.ActiveDocument.Application.Quit()
    



    六、数据转换


      目的: 为了保证程序的顺利运行,用户输入的数据类型需转换成 CAD 能识别的数据类型。


      说明: 本人非计算机专业出身,以下表述纯属个人理解,不妥/错误之处还请各位批评指正。


      Python 中的数据类型较少,且对数据本身的要求也较为宽松,如一个列表中的各个元素可以分别属于不同的数据类型,这虽然有利于降低程序的编写难度,但也对 CAD 的二次开发产生了一些不必要的麻烦。


      在 CAD 二次开发过程中,很多函数/方法的参数要求输入的数据类型为 Variant (array of objects) ,但在 Python 中似乎又没有哪一种数据类型与之直接相对应,若采用 list 代替 Variant,那么程序无法顺利执行,报错为 “ 对象数组无效 ”。因此,需要某种转换方式,将 Python 中定义的变量转换为能够被 CAD 识别的数据类型 Variant


      VARIANT 结构体主要是使用在 COM(组件对象模型)中用于传递参数使用,它的存在主要是为了保持一个在 COM 参数传递方法的统一性,它几乎包含了所有普通常用类型的数据类型的传递,如整型,浮点型,布尔型等,以及相应类型的指针类型,如整型指针。[2]



      部分类型与变量对应关系如下表:


    Member name Description
    VT_EMPTY Indicates that a value was not specified.
    VT_R8 Indicates a double value.
    VT_DISPATCH Indicates an IDispatch pointer.


      另外,NumPy arrays can be passed as VARIANT arrays arguments. The array is converted to a SAFEARRAY according to its type. [3] ( 此为 comptypes 库帮助文档原文,本人对计算机了解有限,为了不曲解原文,此处不做翻译),部分对应关系如下:


    NumPy type VARIANT type
    int32, int, intc, int_ VT_I4
    uint32, uint, uintc VT_UI4
    float64, float_ VT_R8


      comtypes 是一个轻量级的 python com 包,其中文网站详见:https://www.cnpython.com/pypi/comtypes;官方文档详见:comtypes 1.1.3 documentation


      NumPy 是用 Python 进行科学计算的基础软件包,其官方的中文文档详见网站: Numpy 中文网


      在 Python 调用 AutoCAD 过程中,常用的数据转换函数如下:


    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    import win32com.client
    import pythoncom
    
    wincad = win32com.client.Dispatch("AutoCAD.Application.19")  
    doc = wincad.ActiveDocument
    doc.Utility.Prompt("Hello! Autocad from pywin32.")
    msp = doc.ModelSpace
    print(doc.Name)
    
    def vtpnt(x, y, z=0):
        """坐标点转化为浮点数"""
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_R8, (x, y, z))
    
    def vtobj(obj):
        """转化为对象数组"""
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_DISPATCH, obj)
    
    def vtfloat(lst):
        """列表转化为浮点数"""
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_R8, lst)
        
    def vtint(lst):
        """列表转化为整数"""
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_I2, lst)
    
    def vtvariant(lst):
        """列表转化为变体"""
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_VARIANT, lst)
    


    七、绘图


      本部分仅介绍一些复杂图形的绘制,更多基础图形的绘制详见博客:Python AutoCAD 绘图


    7.1 倒角矩形


    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    from pyautocad import Autocad, APoint, aDouble
    import math
    
    pyacad = Autocad(create_if_not_exists=True)
    pyacad.prompt("Hello! AutoCAD from pyautocad.")
    print(pyacad.doc.Name)
    
    [L, B, R] = [400, 200, 50]  # L、B、R分别为矩形的长度、矩形的宽度及圆角半径。
    
    x = [0.5 * (L - 2 * R), 0.5 * L]  # 倒角矩形各关键点横坐标的绝对值;
    y = [0.5 * (B - 2 * R), 0.5 * B]  # 倒角矩形各关键点纵坐标的绝对值;
    
    pnts = [APoint(x[0], -y[1]), APoint(x[1], -y[0]), APoint(x[1], y[0]),
            APoint(x[0], y[1]), APoint(-x[0], y[1]), APoint(-x[1], y[0]),
            APoint(-x[1], -y[0]), APoint(-x[0], -y[1])]
    
    pnts = [j for i in pnts for j in i]  # 将各点坐标顺序变换为行数据
    pnts = aDouble(pnts)  # 转化为双精度浮点数
    
    plineObj = pyacad.model.AddPolyLine(pnts)
    plineObj.Closed = True  # 闭合多段线
    bulgeValue = math.tan(math.pi / 8)  # 凸度,为四分之一倍圆弧所对圆心角的正切值。
    
    [plineObj.SetBulge(2 * i, bulgeValue) for i in range(4)]  
    # 将多段线的第1、3、5、7部分设置为凸度为bulgevalue的圆弧。
    

    在这里插入图片描述

    倒角矩形


    7.2 闭合多段线图案填充


    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    import pythoncom
    import win32com.client
    
    wincad = win32com.client.Dispatch("AutoCAD.Application")
    doc = wincad.ActiveDocument
    doc.Utility.Prompt("Hello! AutoCAD from pywin32.")
    msp = doc.ModelSpace
    
    def vtobj(obj):
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_DISPATCH, obj)
    
    def vtfloat(lst):
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_R8, lst)
    
    
    [ptnName, ptnType, bAss] = ["ANSI31", 0, True]
    
    pnts = [100, -50, 0, 100, 50, 0, -100, 50, 0, -100, -50, 0]
    pnts = vtfloat(pnts)
    
    plineObj = msp.AddPolyLine(pnts)
    plineObj.Closed = True
    
    outerLoop = []
    outerLoop.append(plineObj)
    outerLoop = vtobj(outerLoop)
    hatchObj = msp.AddHatch(ptnType, ptnName, bAss)
    hatchObj.AppendOuterLoop(outerLoop)
    hatchObj.Evaluate()  # 进行填充计算,使图案吻合于边界。
    

    在这里插入图片描述

    闭合多段线的图案填充



    7.3 动态块


      创建动态块的标准流程为:创建普通块(B) → 编辑块 → 指定参数 → 设置动作,详见: AutoCAD-如何创建动态块


      创建如下图所示的动态块,块的名称为 door,由矩形、圆弧及直线三个图元构成,并具有三种用户自定义状态,分别为缩放、旋转和翻转。


    在这里插入图片描述


    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        ==============================
        Author: Wang Yifang (SINOMACH)
        ==============================
    """
    
    import win32com.client
    acad = win32com.client.Dispatch("AutoCAD.Application")
    
    # iterate through all objects (entities) in the currently opened drawing
    # and if its a BlockReference, display its attributes.
    
    for entity in acad.ActiveDocument.ModelSpace:
        name = entity.EntityName
        print(name)
        if name == 'AcDbBlockReference':
            if entity.IsDynamicBlock:
                print("Is dynamic block")
    
            block_ = entity.GetDynamicBlockProperties()
            print(block_)
            print("print property")
            for p in block_:
                print("{")
                print(p.AllowedValues)
                print(p.Description)
                print(p.PropertyName )
                print(p.ReadOnly)
                print(p.Show)
                print(p.UnitsType)
                print(p.Value)
                print("}")
                print("===================================")
                # 修改动态块的尺寸
                if p.PropertyName == "距离1":
                    p.Value = float(10)
                if p.PropertyName == "角度1":
                    p.Value = float(3.14159265/3)
                    # 角度为弧度制
                # if p.PropertyName == "翻转状态1":
                #     p.Value = 1
                # 此功能报错,原因待查明。
    

    在这里插入图片描述


    长度10 旋转60度



    八、颜色


      在 AutoCAD 中,颜色设置是普遍存的,如设置图层的颜色,指定标注文字的颜色等等。多数情况下可以通过设置 RGB 值来实现,但有时需要直接指定一个数字来代表该颜色。在此,把代表该颜色的数值变量称为 颜色标识号 (可能有专门的术语,管它呢,我就这么叫,爱谁谁),用 clr 表示。某一颜色的 clr 值可由该颜色的 RGB 值计算得到,计算公式如下:


    clr=R+256×G+256×256×B {clr} = R + 256 × G + 256 × 256 × B


      例如: 对于白色(R=255,G=255,B=255),其对应的颜色标识号 clr 为 255 + 256 × 255 + 256 × 256 × 255 = 16777215。


      根据上述公式,几种常用的标准颜色的颜色标识号如下:


    颜色 clr 颜色 clr
    黑色 0 青色 16776960
    红色 255 蓝色 16711680
    黄色 65535 洋红 16711935
    绿色 65280 白色 16777215


      • 示例


      将 AutoCAD 程序的模型空间背景色设置成如下所示的淡绿色:


    在这里插入图片描述

    R=198 G=224 B=180

    clr=198+256×224+256×256×180=11854022 {clr} = 198 + 256 × 224 + 256 × 256 × 180 = 11854022

    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    from pyautocad import Autocad
    
    pyacad = Autocad(create_if_not_exists=True)
    pyacad.prompt("Hello! AutoCAD from pyautocad.")
    print(pyacad.doc.Name)
    
    clr = 11854022
    pyacad.ActiveDocument.Application.preferences.Display.GraphicsWinModelBackgrndColor = clr
    

    在这里插入图片描述

    模型空间背景色的设置


      该功能的实现历经波折,卡顿了近三个月,终于,在那一天下班铃响后测试成功。


      值得注意的是,不是所有的颜色指定都可以采用该种方式,如图案填充颜色的设置就是通过直接设置 RGB 的方式实现的。


      蓝色的定义: doc.Application.GetInterfaceObject(“AutoCAD.AcCmColor.19”).SetRGB(0, 0, 255) 。




    九、重要方法


    9.1 SendCommad


    在这里插入图片描述

    SendCommand方法


      极个别情况下,采用常规方式很难实现某一功能,如设置默认视图、定义永久标注样式等。此时,可尝试采用 SendCommand 方式来实现。具体方法为,先在 AutoCAD 软件界面操作一遍,然后查看在此过程中提示工具栏内的数据变化,最后,将这些变化稍加改动按照 CAD 二次开发的规则输入到 SendCommand 内,即可得到相应的 Python 代码。


      以直线的绘制为例,在 AutoCAD 软件中的操作步骤为:输入绘制直线的快捷命令 “L” > 回车 > 屏幕上点选第一个点 > 回车 > 屏幕上点选第二个点 > 回车,直觉告诉我们 SendCommand 括号内数据输入也应该是这一顺序,即


    SendCommand ("L" + 回车 + 第一个点坐标 + 回车 + 第二个点坐标 + 回车)


    在这里插入图片描述

    直线绘制过程中命令栏内的显示情况


    在这里插入图片描述

    SendCommand方式绘制直线的Python代码


      另一个典型的例子是将程序的预设视图由俯视变更为西南等轴测,将视觉样式由二维线框变更为真实,在 CAD 界面操作后,命令栏让将显示出如下数据:



    在这里插入图片描述

    预设视图及视觉样式的修改


    在这里插入图片描述

    预设视图及视觉样式修改过程中命令栏内的显示情况



      显然,实现这两项功能的 Python 代码为:


    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    from pyautocad import Autocad
    
    pyacad = Autocad(create_if_not_exists=True)
    pyacad.prompt("Hello! AutoCAD from pyautocad.")
    print(pyacad.doc.Name)
    
    pyacad.ActiveDocument.SendCommand("_-view" + chr(13) + "_swiso" + chr(13))  # 定义预设视图为西南等轴测。
    pyacad.ActiveDocument.SendCommand("_vscurrent" + chr(13) + "_R" + chr(13))  # 视图样式设置为真实。
    

      值得注意的是,不是所有的功能均可由该方式实现,极其个别的功能就实现不了,但是这些功能通常也没必要采用二次开发的方式实现,直接点下软件界面不好么。



    9.2 GetEntity


      更多图元选择即选择集功能的实现,详见博客:Python AutoCAD 选择集


    在这里插入图片描述


      以下代码实现将所选图元的颜色更改为红色。


    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    import pythoncom
    import win32com.client
    import math
    
    wincad = win32com.client.Dispatch("AutoCAD.Application")
    doc = wincad.ActiveDocument
    doc.Utility.Prompt("Hello! Autocad from pywin32com.\n")
    msp = doc.ModelSpace
    print(doc.Name)
    
    def vtpnt(x, y, z=0):
        """坐标点转化为浮点数"""
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_R8, (x, y, z))
    
    pnt1, pnt2, pnt3 = vtpnt(-40, -40), vtpnt(500, 500), vtpnt(300, 200)
    lineObj = msp.AddLine(pnt1, pnt2)
    circleObj = msp.AddCircle(pnt3, 100)
    
    print("请在CAD程序界面点选图元,未选中则报错!")  # try...except处理报错
    rtnObj = doc.Utility.GetEntity()  # 返回对象
    
    print(rtnObj)
    print("所选图元的ID:", rtnObj[0].ObjectID)
    print("鼠标单击处的坐标:", rtnObj[1])
    
    sltObject = doc.ObjectIdToObject(rtnObj[0].ObjectID) # 图元ID转化为对应的图元
    
    clr = doc.Application.GetInterfaceObject("AutoCAD.AcCmColor.19")
    clr.SetRGB(255, 0, 0)  # 创建红色
    sltObject.TrueColor = clr  # 指定颜色
    
    doc.Application.Update()
    

    9.3 SetXData/GetXData

    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    # This example creates a line and attaches extended data to that line.
    
    import pythoncom
    import win32com.client
    
    wincad = win32com.client.Dispatch("AutoCAD.Application")
    doc = wincad.ActiveDocument
    doc.Utility.Prompt("Hello! Autocad from pywin32com.\n")
    msp = doc.ModelSpace
    print(doc.Name)
    
    def vtpnt(x, y, z=0):
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_R8, (x, y, z))
    
    def vtfloat(val):
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_R8, val)
    
    def vtint(val):
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_I2, val)
    
    def vtvariant(var):
        return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_VARIANT, var)
    
    # Create the line
    
    startPntCoords = vtpnt(1, 1, 0)
    startPoint = msp.AddPoint(startPntCoords)
    endPntCoords = vtpnt(5, 5, 0)
    endPoint = msp.AddPoint(endPntCoords)
    lineObj = msp.AddLine(startPntCoords, endPntCoords)
    
    # Initialize all the xdata values. Note that first data in the list should be
    # application name and first datatype code should be 1001
    
    DataType = [1001, 1000, 1003, 1040, 1041, 1070, 1071, 1042]
    Data = ["Test_Application", "This is a test for xdata",
            "0", 1.23479137438413E+40, 1237324938, 32767, 32767, 10]
    reals3 = [-2.95, 100, -20]
    # DataType.append(1010)
    # Data.append(reals3)
    # worldPos = [4, 400.99999999, 2.798989]
    # DataType.append(1011)
    # Data.append(worldPos)
    
    DataType = vtint(DataType)
    Data = vtvariant(Data)
    # Attach the xdata to the line
    lineObj.SetXData(DataType, Data)
    
    # Return the xdata for the line
    xtypeOut, xdataOut = lineObj.GetXData("Test_Application")
    print(xtypeOut)
    print(xdataOut)
    

      所添加的拓展数据可按如下方式查看: [ObjectARX] ArxDbg介绍、自动加载及其下载


    在这里插入图片描述

    扩展数据的查看



    十、文件


      更多文件相关的操作,详见博客:Python AutoCAD 文件


    10.1 另存为.dwg/.dxf


      以下方法另存为的文件格式只能是 .dwg 和 .dxf,这与在 CAD 软件中,依次点击 文件 >> 另存为 是相对应的。


    1. 当前文件另存为.dwg/.dxf

      将当前文件另存为 TestSaveAs.dxf,文件的版本是:AutoCAD 2013 DXF,代码如下:

    pyacad.ActiveDocument.SaveAs("D:\\AutoCAD\\TestSaveAs", 61)
    

      上一代码执行完毕后,当前文件被程序关闭,TestSaveAs.dxf 文件被打开,且设定为当前活跃文件。

      参数 61 为 AcSaveAsType enum,表示另存为文件的类型是 AutoCAD 2013 DXF,其他常用类型如下:


    版本 .dwg .dxf
    AutoCAD 2000 12 13
    AutoCAD 2004 24 25
    AutoCAD 2007 36 37
    AutoCAD 2010 48 49
    AutoCAD 2013 60 61

      AcSaveAsType enum 可在官方二次开发帮助文档 ActiveX Develop’s Guide 中查看,查看方式如下图所示:


    在这里插入图片描述



    1. 特定文件另存为.dwg/.dxf

      将特定文件 PyAutoCAD.dwg 另存为 TestSaveAs.dxf,文件的版本是:AutoCAD 2013 DXF,代码如下:

    pyacad.ActiveDocument.Application.Documents("PyAutoCAD.dwg").SaveAs("D:\\AutoCAD\\TestSaveAs", 61)
    


    10.2 另存为.pdf


      首先,确认绘图仪 DWG To PDF.pc3 的工作目录,在搜索神器 Everything 的搜索栏中输入 DWG To PDF.pc3,便可得到绘图仪的工作目录,如下图所示:


    在这里插入图片描述



      另存为 .pdf 文件的 Python 代码如下:


    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    from pyautocad import Autocad
    
    pyacad = Autocad(create_if_not_exists=True)
    pyacad.prompt("Hello! AutoCAD from pyautocad.")
    print(pyacad.doc.Name)
    
    print(pyacad.ActiveDocument.ActiveLayout.ConfigName)
    
    # 设置绘图仪管理器的工作目录
    ACADPref = pyacad.ActiveDocument.Application.preferences.Files
    
    originalValue = ACADPref.PrinterConfigPath \
        = r"C:\Users\33876\AppData\Roaming\Autodesk\AutoCAD 2014\R19.1\chs\Plotters"
    
    print(ACADPref)
    print(originalValue)
    
    oplot = pyacad.ActiveDocument.PlotConfigurations.Add("PDF", acad.ActiveDocument.ActiveLayout.ModelType)
    
    # acad.ActiveDocument.SetVariable("sdi", 0)
    pyacad.ActiveDocument.ActiveLayout.ConfigName = "DWG To PDF.pc3"
    pyacad.ActiveDocument.SetVariable("Filedia", 0)
    
    # acad.ActiveDocument.SetVariable("RASTERPREVIEW", 1)
    pyacad.ActiveDocument.SetVariable("BACKGROUNDPLOT", 0)
    pyacad.ActiveDocument.Plot.QuietErrorMode = True
    
    # acad.ActiveDocument.Plot.PlotToFile("D:\\" + "123" + ".pdf", "Foxit Reader PDF Printer")
    pyacad.ActiveDocument.Plot.PlotToFile("D:\\" + "test" + ".pdf")
    
    oplot.Delete()
    oplot = None
    obj = pyacad.ActiveDocument.GetVariable("DBMOD")
    print(obj)
    

      • 参考资料使用python将cad批量导出至pdf

      本代码只是简单介绍该功能的实现,打印范围等更为详细的设置,请查看二次开发帮助文档。



    10.3 另存为.jpg/.png


      更改绘图仪设置即可,可参考另存为.dpf。


    在这里插入图片描述


    在这里插入图片描述

    确定绘图仪的工作路径

    #!/usr/bin/env python
    # -*- coding: utf-8 -*-
    
    """
        =============================
        Author: DalNur
        Email: liyang@alu.hit.edu.cn
        =============================
    """
    
    import win32com.client
    
    wincad = win32com.client.Dispatch("AutoCAD.Application")
    doc = wincad.ActiveDocument
    doc.Utility.Prompt("Hello! Autocad from pywin32com.\n")
    msp = doc.ModelSpace
    
    print(doc.Name)
    print(doc.ActiveLayout.ConfigName)
    
    # 设置绘图仪管理器的工作目录
    ACADPref = doc.Application.preferences.Files
    
    originalValue = ACADPref.PrinterConfigPath \
        = r"C:\Users\33876\AppData\Roaming\Autodesk\AutoCAD 2014\R19.1\chs\Plotters"
    
    print(ACADPref)
    print(originalValue)
    
    oplot = doc.PlotConfigurations.Add("JPG", doc.ActiveLayout.ModelType)
    
    doc.ActiveLayout.ConfigName = "PublishToWeb JPG.pc3"
    doc.SetVariable("Filedia", 0)
    
    doc.SetVariable("BACKGROUNDPLOT", 0)
    doc.Plot.QuietErrorMode = True
    
    doc.Plot.PlotToFile("D:\\" + "test" + ".jpg")
    
    oplot.Delete()
    oplot = None
    obj = doc.GetVariable("DBMOD")
    print(obj)
    

      CAD转化为JPG后,图片模糊不清楚怎么办 ?




    十一、致谢


      特别感谢 ke1078 同学提供的无私帮助,使得 Python 语言二次开发 AutoCAD 的许多高级功能得以顺利实现。




    十二、说明


      2018年12月13日,该系列博客仅仅以一篇名为 【Python pyautocad库 使用简介】 的博客形式出现在 CSDN 上。为了清晰直观,2019年7月20日左右,博主以博客【Python pyautocad库 使用简介】为基础,按部分将原文扩展成 9 篇博客,后续又陆续进行了修改和编辑,特此说明。这 9 篇博客以 AutoCAD 草图与注释 工作空间菜单栏内的功能区分为标准,较为详细地介绍了 Python 调用 AutoCAD 相关功能的实现。码字不易,转载还请注明出处!


    在这里插入图片描述

    AutoCAD草图与注释


    转载请注明出处!

    转载请注明出处!

    转载请注明出处!



    在这里插入图片描述

    原博客部分内容

      这 9 篇博客分别是:


         - Python 二次开发 AutoCAD 简介

         - Python 二次开发 AutoCAD 系统设置

         - Python 二次开发 AutoCAD 图层

         - Python 二次开发 AutoCAD 绘图

         - Python 二次开发 AutoCAD 修改

         - Python 二次开发 AutoCAD 块组

         - Python 二次开发 AutoCAD 注释

         - Python 二次开发 AutoCAD 文件

         - Python 二次开发 AutoCAD 选择集




    十三、尾声


      以上,便是 Python 语言二次开发 AutoCAD 的简单介绍。

      因篇幅有限,某些非关键功能未做详细介绍,如有疑问,欢迎邮件交流。

      Email: liyang@alu.hit.edu.cn

      仅以此文为我断断续续一年多的 Python 调用 AutoCAD 的相关工作做一个总结。

      与此同时,也希望能够为初学者/有需要的人提供多一点参考。

      本文仅用于个人学习,除此之外,无其他任何用途。

      因个人水平有限,文中难免有所疏漏,还请各位大神不吝批评指正。

      胸藏文墨怀若谷,腹有诗书气自华,希望各位都能在知识的 pāo 子里快乐徜徉。

      本文最早发表于 2018-12-13 18:20:21,最后修改于 2020-4-25 22:02:07。

      如无特殊原因,不再更新!

      本文逻辑清楚,内容详实,引例丰富。

      欢迎大家点赞、评论及转载,转载请注明出处!

      为我打call,不如为我打款!

      打赏可备注邮箱,本人将赠送本系列博客的全部 Python 源代码。

      最后,祝各位攻城狮们,珍爱生命,保护发际线!



    在这里插入图片描述




    十四、参考文献


    [1]. 使用Python读写DXF和DWG文件. 大专栏.

    [2]. VARIANT的使用方法. xinzhiyounizhiyouni.

    [3]. comtypes 1.1.3 documentation




    展开全文
  • 1、首先需要安装ZhongJunTools AutoCAD插件,下载地址:https://process-equips.com/cad 可以选择"在线安装包"下载 2、下载完成后解压安装包文件,并执行安装包中的 Install.exe 安装程序。 3、软件安装界面将...

    1、首先需要安装ZhongJunTools AutoCAD插件,下载地址:https://process-equips.com/cad 可以选择"在线安装包"下载
    在这里插入图片描述
    2、下载完成后解压安装包文件,并执行安装包中的 Install.exe 安装程序。
    在这里插入图片描述
    在这里插入图片描述
    3、软件安装界面将打开,点击“安装”按钮执行安装操作,稍后将显示安装完成。
    在这里插入图片描述
    在这里插入图片描述
    4、安装完成后在AutoCAD中打开如下菜单,选择“导出Excel”
    在这里插入图片描述
    5、然后选择AutoCAD文件中对应的表格(不能漏选表格中的直线)。回车键确定,弹出文件保存对话框,打开保存的Excel文件即可看到 导出的表格
    ![在这里插入图片描述](https://img-blog.csdnimg.cn/img_convert/bb8ad39f4f78f767c94744b9e42c3ef6.png#pic_center
    在这里插入图片描述
    在这里插入图片描述
    在这里插入图片描述

    展开全文
  • CAD2018下载AutoCAD2018下载安装详细教程附软件下载

    万次阅读 多人点赞 2019-06-13 20:20:36
    AutoCAD2018是广大绘图从业者必备的软件,它强大的功能可以绘制出各个行业的完整施工图,准确的尺寸更是有利于施工团队完全按照图纸进行施工操作; 但对于很多初学者来说,软件安装的诸多步骤使其望而却步,为此,我...

    此文,我主要为你分享CAD2018软件下载和安装的详细步骤,这是一款应用于室内、建筑、机械、工业、园林等诸多行业的必备软件,作为从业者是必备同样的专业能力,才能根据要求完成精确的图纸,便于施工人员根据准确的图纸进行施工操作;

    但很多朋友跟我反馈不懂在哪下载软件、也不清楚怎么安装AutoCAD软件,为此我把自己亲测好用的安装包分享出来,并且亲自录制了安装视频教程也编写了图文教程,方便你下载安装使用。

    AutoCAD2018(32位)安装包:https://pan.baidu.com/s/1HBoxUb-qdx-giqFoxPfTrw
    AutoCAD2018(64位)安装包:https://pan.baidu.com/s/1FnAeYMdf_UrLn34kWjrDtw
    (32位和64位请根据自己的电脑系统进行选择下载,匹配即可)

    下载方法:电脑打开浏览器,复制下载链接,粘贴至浏览器网址栏(网址栏哦,网址,不是百度搜索框)打开,点保存到网盘,然后打开自己的网盘客户端,找到保存的CAD2018安装包,用鼠标右键单击,点下载,等待下载完成即可;

    一、安装视频教程

    https://v.qq.com/x/page/h0863xp4o41.html
    观看1080P高清蓝光更清晰:复制链接粘贴至电脑浏览器或腾讯客户端打开即可;

    二、安装图文教程

    1、解压AutoCAD2018软件安装包,进入解压出来的文件夹;
    用鼠标右键单击已经下载好的AutoCAD2018的软件包,点解压到当前文件夹,解压完成之后,双击进入新解压出来的文件夹内;
    在这里插入图片描述
    2、打开自解压程序,选择解压路径;
    双击打开AutoCAD2018的自解压程序,点更改,选择当前的文件夹为解压路径,点击确定,开始解压所有AutoCAD2018安装所需的程序,等待所有程序解压完成;
    在这里插入图片描述
    3、点击安装;
    自解压完成之后,会自动出现AutoCAD2018的安装界面,直接点击安装;
    在这里插入图片描述
    4、许可协议点我接受,再点下一步;
    许可协议内容较长,若你有时间,可以阅览一番,加深对软件的了解,若时间紧凑的话,直接点击我接受,再点下一步;
    在这里插入图片描述
    5、点击浏览,配置安装路径;
    安装路径依然选择当前文件夹,这里切记不要安装到C盘系统盘,否则电脑在后期制图的过程中会非常卡,配置好,点击安装,等待所有程序安装完成即可;
    尽量不要选择C盘,其他的DEF盘,你可以根据自己平时的安装习惯随便选;
    在这里插入图片描述
    6、安装完成,点击完成;
    所有程序安装完成之后,会显示成功,现在点击完成,点击之后可能会出现提示你是否要重启电脑,点否,等我们接下来更重要的步骤完成后,再重启;
    在这里插入图片描述在这里插入图片描述
    7、打开CAD2018软件;
    桌面找到AutoCAD2018软件图标,双击打开,或者右键单击选择以管理员身份运行;
    在这里插入图片描述
    8、选择输入序列号;
    这个界面有三个选项,而我们是要对软件进行激活使用,所以直接点击中间的输入序列号;
    在这里插入图片描述
    9、我同意隐私声明;
    这是软件对于我们自身的操作出的声明,直接点我同意即可;
    在这里插入图片描述
    10、第一次点击激活;
    这是首次进入激活界面,如果在未激活的状态下,是试用软件30天,我们直接一次完成,免去以后的麻烦;
    在这里插入图片描述
    11、输入AutoCAD2018匹配的序列号666-69696969,密钥001J1,点击下一步;
    序列号和密钥一定要输入正确且和软件版本匹配,如果有一个字母输入错误的话,都无法完成。
    在这里插入图片描述
    12、先点重新输入,再点Yes;
    这里有的会出现,有的电脑不会出现,当出现的时候,没关系,点击后退,再点yes;
    在这里插入图片描述
    13、第二次点击激活;
    现在再次回到许可激活界面,还是一样的步骤,第二次点击激活;
    在这里插入图片描述
    14、第二次输入AutoCAD2018序列号666-69696969,密钥001J1,点击下一步;
    在这里插入图片描述
    15、选择第二个我有激活码;
    现在正式进入到AutoCAD2018的激活选项界面,点击第二个,我有激活码,激活码需要通过匹配的注册机在自己的电脑上计算得出,别人无法代劳,必须自己计算;
    在这里插入图片描述
    16、右键单击注册机,选择以管理员身份运行;
    回到解压AutoCAD2018的文件夹,进入注册机文件夹,找到注册机,鼠标右键单击,选择以管理员身份运行;
    在这里插入图片描述
    17、先点Patch再点确定;
    运行打开注册机之后,直接点击Patch,出现一个小提示框,点确定;
    在这里插入图片描述
    18、计算激活码详细步骤;
    1)复制申请号,粘贴至注册机第一行;
    2)点击Generate生成激活码;
    3)双击注册机第二行的激活码全选,复制,粘贴至激活选项界面;
    4)点下一步;
    请用快捷键复制粘贴,Ctrl+C是复制,Ctrl+V是粘贴,申请号和激活码都不要手动输入,都用快捷键复制粘贴;
    在这里插入图片描述
    19、感谢您激活AutoCAD2018,点击完成;
    在这里插入图片描述
    20、打开软件,进入AutoCAD2018软件操作界面,就可以正常使用了;
    在这里插入图片描述
    AutoCAD2018(32位)安装包:https://pan.baidu.com/s/1HBoxUb-qdx-giqFoxPfTrw
    AutoCAD2018(64位)安装包:https://pan.baidu.com/s/1FnAeYMdf_UrLn34kWjrDtw
    (32位和64位请根据自己的电脑系统进行选择下载,匹配即可)

    下载方法:电脑打开浏览器,复制下载链接,粘贴至浏览器网址栏(网址栏哦,网址,不是百度搜索框)打开,点保存到网盘,然后打开自己的网盘客户端,找到保存的CAD2018安装包,用鼠标右键单击,点下载,等待下载完成即可;

    AutoCAD2018安装视频教程:https://v.qq.com/x/page/h0863xp4o41.html
    观看1080P高清蓝光更清晰:复制链接粘贴至电脑浏览器或腾讯客户端打开即可;

    展开全文
  • AUTOCAD2020安装包&安装教程

    万次阅读 多人点赞 2019-05-10 20:00:17
    AutoCAD是目前计算机辅助设计领域最流行的CAD软件,此软件功能强大、使用方便,在国内外广泛应用于机械、建筑、家居、纺织等诸多行业。 CAD2020新增功能: 1.全新的暗色主题,提供更柔和的视觉和更清晰的视界。 2....

    下载安装包路径:

    链接:https://pan.baidu.com/s/1vKC8ktLaNAdkxALJpu2rNA
    提取码:d775

    CAD2020安装过程

    AutoCAD是目前计算机辅助设计领域最流行的CAD软件,此软件功能强大、使用方便,在国内外广泛应用于机械、建筑、家居、纺织等诸多行业。
    CAD2020新增功能:
    1.全新的暗色主题,提供更柔和的视觉和更清晰的视界。
    2.保存速度只需 0.5 秒,比上一代整整快了 1 秒。固态硬盘安装时间缩短了 50%。
    3.“快速测量”工具允许通过移动/悬停光标来动态显示对象的尺寸,距离和角度数据。
    4.增加新块调色板,可以提高查找和插入多个块的效率。
    5.重新设计的清理工具更新过后更实用和人性化。
    6.在一个窗口中比较图纸的修订DWG Compare 功能已经得到增强。
    7.云存储应用程序集成AutoCAD 2020 已经支持 Dropbox,OneDrive 和 Box 等多个云平台,这些选项在文件保存和打开的窗口中提供。
    安装步骤
    1.选中【CAD2020】压缩包,鼠标右击选择【解压到CAD2020】。
    1
    2.双击打开【CAD2020】文件夹。
    2
    3.双击打开【安装包】文件夹。
    3
    4.选中【Setup】可执行文件,鼠标右击选择【以管理员身份运行】。
    4
    5.点击【安装】。
    5
    6.选择【我接受】,然后点击【下一步】。
    6
    7.点击【浏览】更改软件的安装路径,建议安装在除C盘之外的其他磁盘,可以在D盘或其他盘新建一个【CAD2020】文件夹,然后点击【安装】。
    7
    8.安装中。(大约10分钟左右)
    8
    9.点击【立即启动】。
    9
    10.点击【OK】。
    10
    11.点击【输入序列号】。
    11
    12.点击【我同意】。
    12
    13.点击【激活】。
    13
    14.序列号输入【666-69696969】,产品密钥输入【001L1】,然后点击【下一步】。
    14
    15.点击【后退】然后点击【Yes】。
    15
    16.点击【激活】。
    16
    17.序列号输入【666-69696969】,产品密钥输入【001L1】,然后点击【下一步】。
    17
    18.打开之前解压后的【CAD2020】文件夹,选中【xf-adesk20】可执行文件鼠标右击选择【以管理员身份运行】。
    温馨提示:若没有【xf-adesk20】文件,请关闭电脑杀毒软件和防火墙(Win10系统还需要关闭Defender)后再重新解压。
    18
    19.使用快捷键Ctrl+C复制【申请号】,在注册机的【Request】处使用快捷键Ctrl+V粘贴(记得删除原Request中的内容),然后点击【Path】。
    19
    20.点击【确定】。
    20
    21.选择【我具有Autodesk 提供的激活码】然后点击【Generate】,使用快捷键Ctrl+C复制注册机中生成的激活码,然后使用快捷键Ctrl+V粘贴到软件的激活码输入框中。
    21
    22.点击【下一步】。
    22
    23.激活成功,点击【完成】。
    23
    24.安装完成,打开软件界面如下。
    24

    安装完成(素材来源于[软件安装管家])

    喜欢的话,记得点赞关注

    展开全文
  • AutoCAD2020中文版为目前最新软件版本,我第一时间拿到软件进行安装测试,确保软件正常安装且各项功能正常可以使用,立刻拿出来分享,想用最新版本的话,抓紧下载使用吧; 我把我用的安装包贡献给你下载链接:...
  • cad版本转换器 cad转换 autocad版本 cad2010转换 cad高版本转低版本 可转换R14-2010的所有版本,汉化crack版,安装完直接可用。
  • CAD2016下载AutoCAD2016下载安装详细教程CAD下载

    千次阅读 多人点赞 2019-08-16 15:41:47
    AutoCAD2016是众多设计从业者使用比较广泛的软件,此篇文章主要分享软件的下载、安装与激活的详细步骤,为此我也分享自己亲测好用的AutoCAD2016的软件版本,希望对你有所帮助; AutoCAD2016中文(64位)安装包下载...
  • 今天我带来的分享是AutoCAD2021中文下载安装详细教程,纯个人经验,希望你能用得上; AutoCAD2021(64位)网盘下载链接: https://pan.baidu.com/s/1ppxY286sM-dUo2epAoJWVg 提取码:8qhm AutoCAD2021(64位)迅雷...
  • 2019CAD设置经典模式模板&详细步骤

    万次阅读 多人点赞 2019-05-16 20:53:44
    2019CAD设置经典模式步骤 第一步:下载经典模式模板 链接:https://pan.baidu.com/s/1Wyt0SQxqOG1nETg55rHq-w 提取码:lpxq 第二步:安装 1 2打开AutoCAD2016,找到工具里面的自定义-界面-传输 4点击左上角传输,...
  • autocad高版本转低版本 cad版本转换 cad2012转低版本 autocad版本转换器
  • 在使用aspose.cadCAD转PDF时,发现如果CAD文件存在3D图形时, 就会转换失败,PDF内容为空。需要设置TypeOfEntities.Entities3D,但是设置了这个属性2D图片又转换不了。 所以想问下怎么判断CAD文件是否为3D
  • 你好,此文我主要为你分享关于CAD2018下载方法和安装详细教程,因为很多朋友最近找我说想用2018但不知道从哪下载也不清楚怎么安装,我把我自己再用的CAD2018分享出来,同时我自己亲自录制了安装视频教程以及亲自编写...
  • 还在找工作?零基础30天成为室内设计师!...适用于AutoCAD及浩辰CAD等与ACAD类似的CAD软件。   单击标题成绩即可翻开相关文档,在成涛CAD博客首页左侧“搜博主文章”中输出关头字可以快速找出相关的文
  • AutoCAD 2019是一款常用的专业制图软件,有些用户想要更新AutoCAD新版本,卸载的时候却发现卸载不干净,新版本安装不上的困扰。针对此问题macdown小编为您带来一篇关于”AutoCAD 2019 如何彻底卸载的详细操作教程...
  • 在日常的工作中,最长使用的CAD办公软件就是CAD编辑器,一般大家都知道CAD编辑器都是用来编辑CAD图纸的。其实编辑器也还有许多的功能的,就比如说可以修复损坏的CAD图纸,那么如何在CAD中修复CAD图纸呢?具体该如何...
  • CAD工具栏不见了怎么显示出来 CAD面板不见了怎么显示出来 解决方法一: 1、打开“工具”->“选项”->“配置”->“重置”。 解决方法二: 1、切换工作空间 ...
  • CAD制图

    2017-08-21 09:32:42
    CAD页面图(对照以下图标,你就会知道图标的作用) (图一) 图中的(图标、命令、快捷键、命令说明)形象的描述CAD快捷键的应用,让你几分钟就学会CAD,快速画图。 (图二) 图中的(图标、命令、快捷键、...
  • 楼主也查过网上关于如何解决CAD安装失败的一些文章,是说删除几个CAD文件和CAD软件注册表就可以解决CAD安装失败的问题,实际的情况并没有这么简单,导致CAD安装失败的原因有很多种。CAD安装时产生了几万条注册表,想...
  • AutoCAD

    2018-09-05 19:52:58
    AutoCAD_2011 ed2k://|file|AutoCAD_2011_EKST_Win_32bit.exe|2948894139|aa292e27fe94f97907063b702da2b48b|h=4rq72iwzfehzw3gumgn6enduvdknhv27|/ ed2k://|file|AutoCAD_2011_EKST_Win_64bit.exe|3134319382|20f...
  • 学习CAD绘图的朋友们,我们在初学CAD制图的时候,会接触到CAD角度标注命令的快捷键“DAN”。今天我就和大家演示一下,CAD角度标注命令,标注CAD图纸的演示操作。演示步骤入如下: 运行CAD编辑器软件,在CAD窗口中...
  • Autodesk CAD卸载工具(AUTO Uninstaller)是专门为了针对Autodesk CAD软件卸载不干净而导致CAD安装失败问题进行研发的Autodesk CAD一键卸载工具。现在虽然像360或者其他一些卸载软件提供了强力卸载CAD的工具,可以将...
  • CAD字体HZTXT

    千次下载 热门讨论 2010-03-15 17:02:41
    CAD字体HZTXT,CAD安装必需字体
  • 在使用AutoCAD绘图软件的时候,如果不小心把CAD菜单栏隐藏了,有多数同学都不在在哪,一些时候操作CAD,突然的命令栏就不见了,对于CAD的编辑操作十分不便,CAD菜单栏怎么调出来?下面,小编给大家讲解CAD命令栏不见...
  • 解决CAD启动假死卡死

    万次阅读 2018-05-28 19:18:44
    1、右键CAD图标,添加兼容性。 2、取消证书检查
  • CAD制图初学入门 零基础学CAD要掌握技能精选

    万次阅读 多人点赞 2018-12-13 09:24:52
    第一步:选择CAD制图的种类和对象 大家应该都知道CAD有很多种类,比如机械设计、电气设计、建筑设计、管道设计和服装设计等,那么如果你想要自学CAD,需要确定自己要画什么。 第二步:学习CAD绘图...
  • CAD图库分享好用免费的CAD图纸

    千次阅读 2019-02-19 18:18:25
    CAD图库分享好用免费的CAD图纸。今天我就给大家分享一下。有需要的小伙伴们可以来试一试啊! 1.在浏览器里搜索CAD编辑器,找到CAD编辑器网址。接着点 击官网顶 端的“每日一图”栏,切换到CAD图库“每日一图”。 2....
  • CAD课件

    2008-02-07 16:17:11
    CAD课件CAD课件 CAD课件 CAD课件 CAD课件 CAD课件 CAD课件 CAD课件 CAD课件 <br>
  • 楼主也查过网上关于如何解决AutoCAD安装失败的一些文章,是说删除几个AutoCAD文件和AutoCAD软件注册表就可以解决AutoCAD安装失败的问题,实际的情况并没有这么简单,导致AutoCAD安装失败的原因有很多种。AutoCAD安装...
  • CAD安装失败,怎么把CAD卸载干净呢?有些同学想把CAD重新安装,但是CAD安装失败显示失败,有时CAD安装到一半就显示失败,然后会问CAD无法重装是怎么回事。那么CAD安装失败的原因是什么呢?如何才能把CAD卸载干净呢?...
  • 如何解决CAD绘图界面卡顿的问题1,电脑配置太差,3,通常只打开对象捕捉,另外有一个捕捉打开了,光标也会出现卡顿,2,调用他人的图档,图档太大,块,标注,打印样式等建立的很多,做cad经常卡顿怎么办,求大神帮...

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 45,177
精华内容 18,070
关键字:

cad